<template>
	<div id="analyzer">
		<div class="analyzer-panel">
			<div class="main-column lightestazure-color" ref="board" >
				
				<div class="flex space">
					<div class="energy columns-6 azure-gradient row-padding col-padding">
						<div class="flex space">
							<h3 class="hustle medium">Analyzer</h3>
							
							<div class="actions flex">
								<v-button 
									color="lightestazure" 
									:text="getLocale('analyzed_websites')"
									@clicked="toggle_current_analysis = true"
								/>
								
								<v-button 
									color="lightestazure" 
									:text="getLocale('upgrades')"
									@clicked="toggle_upgrades = true"
								/>
							</div>
						</div>
					
						<div class="flex space">
							<div class="current-energy lightestazure-color" v-if="analyzer">
								<div class="flex space text">
									<div class="bold uppercase">{{ getLocale('energy') }}</div>
									<div class="bold uppercase">{{current_energy}}</div>
								</div>

								<div class="energy-bar">
									<div class="bar">
										<div class="dot lightestazure-border lightestazure-bkg" :style="{left: ((current_energy*100)/analyzer.max_energy)+'%'}"></div> 
										<div class="base lightestazure-bkg" :style="{width: ((current_energy*100)/analyzer.max_energy)+'%'}"></div>
									</div>
								</div>
							</div>
							
							<div class="probes flex">
								<div 
									v-for="n in 3" 
									class="probe azure-border azure-gradient" 
									:class="{disabled : n-1 >= probes.length }" 
								>
									<div class="timer" v-if="probes.length > n-1">{{ parseTime(probes[n-1].end*1000 - current_time) }}</div>
									
									<svg width="100" height="100" viewbox="0 0 100 100" v-if="n <= probes.length">
										<circle cx="50" cy="50" r="43" stroke="#00C2FF" fill="none" stroke-width="5" stroke-dasharray="1 2"/>
										
										<path 
											fill="none" stroke="#00C2FF" 
											stroke-width="7" 
											:d="describeArc(0, probeAngle(probes, n-1), 43, 13)"
										></path>
									</svg>
								</div>
							</div>
						</div>
					</div>
					
					<div class="info-rewards columns-6 azure-gradient row-padding col-padding">
						<h3 class="hustle medium">{{ getLocale('secret_rewards') }}</h3>
						
						<div class="flex space v-center">
							<div class="info-score columns-4">
								<div class="score-bar">
									<div class="bar">
										<div class="base lightestazure-bkg" :style="{width : (milestones*2)+'%'}"></div>
										
										<div class="dot lightestazure-border" :class="{active : milestones >= 2}" style="left: 4%;">
											<div class="vairus"><div class="inner">?</div></div>
										</div>
										
										<div class="dot lightestazure-border" :class="{active : milestones >= 5}" style="left: 10%;">
											<div class="vairus"><div class="inner">?</div></div>
										</div>
										
										<div class="dot lightestazure-border" :class="{active : milestones >= 10}" style="left: 20%;">
											<div class="vairus"><div class="inner">?</div></div>
										</div>
										
										<div class="dot lightestazure-border" :class="{active : milestones >= 25}" style="left: 50%;">
											<div class="vairus"><div class="inner">?</div></div>
										</div>
										
										<div class="dot lightestazure-border" :class="{active : milestones >= 50}" style="left: 100%;">
											<div class="vairus"><div class="inner">?</div></div>
										</div>
									</div>
								</div>
							</div>
							
							<div class="score">{{milestones}}/50</div>
						</div>
						
						<tutorial-icon color="#B3EDFF" @clicked="setTutorial('analyzer_profile', -1, true, 'red')"/>
					</div>
				</div>
						
				<div class="probe-rewards azure-gradient row-padding col-padding" v-if="probes_rewards.length > 0">
					<h3 class="hustle medium">{{ getLocale('probe_rewards') }}</h3>
					
					<div class="rewards flex">
						<div v-for="reward in rewards" class="reward">
						
							<div class="info small-col-padding small-row-padding">
								<div class="flex">
									<div class="columns-6">
										<div>{{formattedTime(reward.time).date}}</div>
										<div>{{formattedTime(reward.time).time}}</div>
									</div>
									<div class="columns-6 align-right">
										<div class="uppercase nowrap">{{ getLocale('probe') }}</div>
									</div>
								</div>
							</div>
							
							<div class="materials small-col-padding small-row-padding flex v-center h-center">
								<div class="bytes">
									<div class="icon" :style="{ 'background-image' : getBytesImage() }"></div>
									<div>{{reward.data.bytes.toLocaleString()}}</div>
								</div>
								<div class="chips">
									<div class="icon" :style="{ 'background-image' : 'url('+getImage('chips.png')+')' }"></div>
									<div>{{reward.data.chips.toLocaleString()}}</div>
								</div>
								<div v-for="(value, shard) in reward.data.shards">
									<div class="icon" :style="{ 'background-image' : getShardImage(shard) }"></div>
									<div>{{value}}</div>
								</div>
								<div v-for="(value, key) in objectKeys(reward.data.keys)">
									<div class="icon" :style="{ 'background-image' : getKeyImage(key) }"></div>
									<div>{{value}}</div>
								</div>
							</div>
				
						</div>
					</div>
				</div>
				
				
				<div class="info-fragments azure-gradient" :style="{transform : 'scale('+ratio+')'}" v-on:click.self="current_info = null">
					<h3 class="hustle medium">{{ getLocale('info_fragments') }}</h3>
					
					<!-- BOXES -->
					
					<div class="container align-center" style="left: 4%;top: 12%;width: 400px;height: 330px;">?</div>
					<div class="container align-center" style="left: 67%;top: 50%;width: 400px;height: 330px;">?</div>
					
					<div class="box" style="left: 69%;top: 82%;" >
						V.
					</div>
					<div class="box" style="left: 72%;top: 52%;" v-if="info_data.set1 && info_data.set1[0] != '00000'">
						H.
					</div>
					<div class="box" style="left: 87%;top: 55%;" v-if="info_data.set1 && info_data.set1[0] != '00000'">
						K.
					</div>
					<div class="box" style="left: 80%;top: 67%;" v-if="info_data.set2 && info_data.set2[0] != '00000'">
						Z.
					</div>
					<div class="box" style="left: 90%;top: 80%;" v-if="info_data.set3 && info_data.set3[0] != '00000'">
						W.
					</div>
					
					<div class="box" style="left: 7%;top: 38%;">
						Wr4ith
					</div>
					
					<div class="box" style="left: 24%;top: 19%;" v-if="info_data.set1 && info_data.set1[1] != '00000'">
						???
					</div>
					
					<div class="box" style="left: 43%;top: 46%;">
						Vairus
					</div>
					
				
					<!-- INFOS -->
					
					<info-fragment 
						v-if="info_data.set1 && info_data.set1[0] != '00000'"
						:info="info_data.set1[0]"
						:active="current_set == 'set1' && current_info == 0"
						:change="changes['set1'] && changes['set1'][0]"
						style="left: 80%;top: 20%;"
						label="VvROw"
						set="set1"
						index="0"
						@clicked="setCurrent('set1', 0)"
					/>
					
					<info-fragment 
						v-if="info_data.set1 && info_data.set1[1] != '00000'"
						:info="info_data.set1[1]"
						:active="current_set == 'set1' && current_info == 1"
						:change="changes['set1'] && changes['set1'][1]"
						style="left: 17%;top: 68%;"
						label="o6097"
						set="set1"
						index="1"
						@clicked="setCurrent('set1', 1)"
					/>
					
					<info-fragment 
						v-if="info_data.set1 && info_data.set1[2] != '00000'"
						:info="info_data.set1[2]"
						:active="current_set == 'set1' && current_info == 2"
						:change="changes['set1'] && changes['set1'][2]"
						style="left: 43%;top: 8%;"
						label="upAxp"
						set="set1"
						index="2"
						@clicked="setCurrent('set1', 2)"
					/>
					
					
					
					
					<info-fragment 
						v-if="info_data.set2 && info_data.set2[0] != '00000'"
						:info="info_data.set2[0]"
						:active="current_set == 'set2' && current_info == 0"
						:change="changes['set2'] && changes['set2'][0]"
						style="left: 59%;top: 36%;"
						label="jZZU4"
						set="set2"
						index="0"
						@clicked="setCurrent('set2', 0)"
					/>
					
					<info-fragment 
						v-if="info_data.set2 && info_data.set2[1] != '00000'"
						:info="info_data.set2[1]"
						:active="current_set == 'set2' && current_info == 1"
						:change="changes['set2'] && changes['set2'][1]"
						style="left: 65%;top: 11%;"
						label="yr4i1"
						set="set2"
						index="1"
						@clicked="setCurrent('set2', 1)"
					/>
					
					<info-fragment 
						v-if="info_data.set2 && info_data.set2[2] != '00000'"
						:info="info_data.set2[2]"
						:active="current_set == 'set2' && current_info == 2"
						:change="changes['set2'] && changes['set2'][2]"
						style="left: 30%;top: 60%;"
						label="VtzHZ"
						set="set2"
						index="2"
						@clicked="setCurrent('set2', 2)"
					/>
					
					
					
					
					<info-fragment 
						v-if="info_data.set3 && info_data.set3[0] != '00000'"
						:info="info_data.set3[0]"
						:active="current_set == 'set3' && current_info == 0"
						:change="changes['set3'] && changes['set3'][0]"
						style="left: 92%;top: 37%;"
						label="nfpLh"
						set="set3"
						index="0"
						@clicked="setCurrent('set3', 0)"
					/>
					
					<info-fragment 
						v-if="info_data.set3 && info_data.set3[1] != '00000'"
						:info="info_data.set3[1]"
						:active="current_set == 'set3' && current_info == 1"
						:change="changes['set3'] && changes['set3'][1]"
						style="left: 5%;top: 78%;"
						label="BW3Ro"
						set="set3"
						index="1"
						@clicked="setCurrent('set3', 1)"
					/>
					
					<info-fragment 
						v-if="info_data.set3 && info_data.set3[2] != '00000'"
						:info="info_data.set3[2]"
						:active="current_set == 'set3' && current_info == 2"
						:change="changes['set3'] && changes['set3'][2]"
						style="left: 44%;top: 72%;"
						label="qs31x"
						set="set3"
						index="2"
						@clicked="setCurrent('set3', 2)"
					/>
					
					<!-- CONNECTIONS -->
					
					<svg viewbox="0 0 1400 787.5" >
					
						<defs>
							<rect width="11" height="11" id="box" fill="#07779F" transform="translate(-5.5 -5.5)"/>
						</defs>
						
						<g>
							<path stroke="#B3EDFF" stroke-width="3"  d="M 456 270 L 602 393" />
							<path stroke="#B3EDFF" stroke-width="3"  d="M 722 393 L 937 570" />
							
							<use xlink:href="#box" x="456" y="270"/>	
							<use xlink:href="#box" x="602" y="393"/>
							
							<use xlink:href="#box" x="722" y="393"/>
							<use xlink:href="#box" x="937" y="570"/>
						</g>
						
						<g v-if="info_data.set3 && info_data.set3[0] != '00000'">
							<path stroke="#B3EDFF" stroke-width="3"  d="M 1327 358 L 1246 433" />
							<path stroke="#B3EDFF" stroke-width="3"  d="M 1327 358 L 1292 629" />
							
							<use xlink:href="#box" x="1327" y="358"/>
							<use xlink:href="#box" x="1292" y="629"/>
						</g>
						
						<g v-if="info_data.set1 && info_data.set1[0] != '00000'">
							<path stroke="#B3EDFF" stroke-width="3"  d="M 1161 223 L 1161 313" />
							<path stroke="#B3EDFF" stroke-width="3"  d="M 1161 313 L 1037 410" />
							<path stroke="#B3EDFF" stroke-width="3"  d="M 1161 313 L 1246 433" />
							
							<use xlink:href="#box" x="1161" y="223"/>
							<use xlink:href="#box" x="1161" y="313"/>
							<use xlink:href="#box" x="1037" y="410"/>
							<use xlink:href="#box" x="1246" y="433"/>
						</g>
						
						<g v-if="info_data.set1 && info_data.set1[1] != '00000'">
							<path stroke="#B3EDFF" stroke-width="3"  d="M 274 424 L 259 548" />
							
							<use xlink:href="#box" x="274" y="424"/>
							<use xlink:href="#box" x="259" y="548"/>
						</g>
						
						<g v-if="info_data.set1 && info_data.set1[2] != '00000'">
							<path stroke="#B3EDFF" stroke-width="3"  d="M 642 129 L 664 362" />
							
							<use xlink:href="#box" x="642" y="129"/>
							<use xlink:href="#box" x="664" y="362"/>
						</g>
						
						<g v-if="info_data.set2 && info_data.set2[0] != '00000'">
							<path stroke="#B3EDFF" stroke-width="3"  d="M 866 350 L 1013 547" />
							<path stroke="#B3EDFF" stroke-width="3"  d="M 1013 547 L 994 646" />
							<path stroke="#B3EDFF" stroke-width="3"  d="M 1013 547 L 1121 558" />
							
							<use xlink:href="#box" x="866" y="350"/>
							<use xlink:href="#box" x="1013" y="547"/>
							<use xlink:href="#box" x="994" y="646"/>
							<use xlink:href="#box" x="1121" y="558"/>
						</g>
						
						<g v-if="info_data.set2 && info_data.set2[2] != '00000'">
							<path stroke="#B3EDFF" stroke-width="3"  d="M 377 210 L 441 486" />
							
							<use xlink:href="#box" x="441" y="486"/>
							<use xlink:href="#box" x="377" y="210"/>
						</g>
						
						<g v-if="info_data.set3 && info_data.set3[1] != '00000'">
							<path stroke="#B3EDFF" stroke-width="3"  d="M 91 628 L 160 360" />
							
							<use xlink:href="#box" x="91" y="628"/>
							<use xlink:href="#box" x="160" y="360"/>
						</g>
						
						<g v-if="info_data.set3 && info_data.set3[2] != '00000'">
							<path stroke="#B3EDFF" stroke-width="3"  d="M 638 581 L 663 422" />
							
							<use xlink:href="#box" x="638" y="581"/>
							<use xlink:href="#box" x="663" y="422"/>
						</g>
					</svg>
				</div>
			
				<transition name="fade">
					<div class="upgrades" v-if="toggle_upgrades">
						<div class="backdrop" v-on:click.self="toggle_upgrades = false"></div>
						
						<div class="main-column" v-on:click.self="toggle_upgrades = false">	
							<div class="wrapper columns-4 center azure-gradient">	
								<div class="header flex space hustle medium">
									<div>{{getLocale('upgrades')}}</div>
									
									<div class="chips flex v-center">
										<number-changer
											:number="chips"
										></number-changer>
											
										<img v-bind:src="getImage('chips.png')">
									</div>
								</div>
								
								<div class="contents">
									<div class="upgrade flex space" v-for="(upgrade, index) in avaialable_upgrades">
										<div class="card lightazure-border">
											<div class="top flex space">
												<div class="name bold uppercase">
													{{ getLocale(upgrade.name) }}
												</div>
												
												<div class="level">LV<span class="bold">{{ upgrade.level }}</span></div>
											</div>
											
											<div class="bottom">
												{{ getLocale(upgrade.name+'_description') }}
											</div>
										</div>
										
										<div 
											class="button" 
											:class="{
												disabled : (upgrade.cost * (upgrade.level+1) > chips),
												lock : upgrade_analyzer_lock
											}"
											v-on:click="upgradeAnalyzer(upgrade, index)"
										>
											<svg class="border" xmlns="http://www.w3.org/2000/svg" width="167" height="74" viewBox="0 0 167 74">
												<path class="bkg" stroke="#00FFB4" stroke-width="2" d="M 30 0 L 167 0 L 167 44 L 137 74 L 0 74 L 0 30 L 30 0" />
											</svg>
											
											<div class="inner flex h-center v-center">
												<svg xmlns="http://www.w3.org/2000/svg" width="30" height="30" viewBox="0 0 30 30">
													<g transform="translate(30 30) rotate(-180)" fill="black">
														<path d="M15,28.125A13.125,13.125,0,1,0,1.875,15,13.125,13.125,0,0,0,15,28.125ZM15,30A15,15,0,1,0,0,15,15,15,0,0,0,15,30Z" transform="translate(0 0)" fill-rule="evenodd"/>
														<path d="M10.4,17.152a.951.951,0,0,1,1.347,0l5.032,5.035,5.033-5.035A.952.952,0,1,1,23.162,18.5L17.456,24.2a.951.951,0,0,1-1.347,0L10.4,18.5a.951.951,0,0,1,0-1.347Z" transform="translate(-1.782 -2.88)" fill-rule="evenodd"/>
														<path d="M17.826,10.125a.951.951,0,0,1,.951.951v9.51a.951.951,0,0,1-1.9,0v-9.51A.951.951,0,0,1,17.826,10.125Z" transform="translate(-2.826 -1.761)" fill-rule="evenodd"/>
													</g>
												</svg>

												<div class="text">
													<div>{{ getLocale('powerup') }}</div>
													<div class="flex">
														<div>{{ (upgrade.cost * (upgrade.level+1)).toLocaleString() }}</div>
														<img class="key" v-bind:src="getImage('chips.png')">
													</div>
												</div>
											</div>
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>
				</transition>
				
				<transition name="fade">
					<div class="current-analysis" v-if="toggle_current_analysis">
						<div class="backdrop" v-on:click.self="toggle_current_analysis = false"></div>
						
						<div class="main-column" v-on:click.self="toggle_current_analysis = false">	
							<div class="wrapper columns-8 center azure-gradient">	
								<div class="header flex space hustle medium">
									<div>{{ getLocale('analyzed_websites') }}</div>
									
									<close-icon color="#B3EDFF" @clicked="toggle_current_analysis = false"/>
								</div>
								
								<div class="contents">
									<div class="container flex lightestazure-border"  v-if="filtered_analysis.length > 0">
										<div class="analysis columns-6 " v-for="analysis in filtered_analysis">
											<div class="inner flex space v-center">
												<div class="url small-col-padding">{{analysis.url}}</div>
												<div class="resources small-col-padding flex v-center h-center">
													<div class="bytes">
														<div class="icon" :style="{ 'background-image' : getBytesImage() }"></div>
														<div>{{analysis.resources[0]}}</div>
													</div>
													<div class="shards">
														<div class="icon" :style="{ 'background-image' : getShardImage('neutral') }"></div>
														<div>{{analysis.resources[1]}}</div>
													</div>
													<div class="keys">
														<div class="icon" :style="{ 'background-image' : getKeyImage('neutral') }"></div>
														<div>{{analysis.resources[2]}}</div>
													</div>
													<div class="chips">
														<div class="icon" :style="{ 'background-image' : 'url('+getImage('chips.png')+')' }"></div>
														<div>{{analysis.resources[3]}}</div>
													</div>
												</div>
											</div>
										</div>
										
										<v-info class="expiration" color="#B3EDFF" :text="timeLeft" v-tooltip="'analysis_expiration_tooltip'" />
									</div>
									
									<div v-else>{{ getLocale('no_analyzed_websites') }}</div>
								</div>
							</div>
						</div>
					</div>
				</transition>
			</div>
		</div>
	</div>
</template>


<script>
	var browser = browser || chrome;

	import { commonMixin } from '../mixins/common.js';
	import { storeGettersMixin } from '../mixins/store_getters.js';
	import TutorialIcon from '../components/TutorialIcon.vue';
	import CloseIcon from '../components/CloseIcon.vue';
	import VInfo from '../components/VInfo.vue';
	import VButton from '../components/VButton.vue';
	import InfoFragment from '../components/InfoFragment.vue';
	import NumberChanger from '../components/NumberChanger.vue';
	
	import analyzer_upgrades from '../data/analyzer_upgrades.json';
	
	export default {
		data: function () {
			return{
				ratio : 1,
				current_set : null,
				current_info : null,
				toggle_upgrades : false,
				toggle_current_analysis : false,
				analyzer_upgrades : analyzer_upgrades
			}
		},
		computed:{
			info_data(){
				var info_data = {};
				
				for(var set in this.info_fragments){
					if(set != 'focus'){
						var infos = this.info_fragments[set];
						
						info_data[set] = [
							infos.substr(0,5),
							infos.substr(5,5),
							infos.substr(10,5),
						];
					}
				}
				
				return info_data;
			},
			changes(){
				var changes = {};
				
				this.fragments_changes.forEach(function(c){
					if(!changes.hasOwnProperty(c.set)){
						changes[c.set] = {};
					}
					changes[c.set][c.info] = true;
				});
				
				return changes;
			},
			current_energy(){
				if(this.analyzer == null) return 0;
				if(this.analyzer.last_analysis == null) return this.analyzer.energy;
				
				var difference = Math.floor(this.current_time/300000) - Math.floor(this.analyzer.last_analysis/300);
				return Math.min(this.analyzer.max_energy, this.analyzer.energy + (difference*this.analyzer.energy_regen));
			},
			probes(){
				return this.processes.filter(function(p){
					return p.type == 'probe';
				});
			},
			rewards(){
				var rewards = this.probes_rewards.map(function(r){
					r.data = JSON.parse(r.data);
					return r;
				});
				
				return rewards.sort(function(a,b){
					return b.time > a.time ? 1 : -1
				});
			},
			avaialable_upgrades(){
				var upgrades = {};		
				this.analyzer_upgrades.forEach(function(upgrade, index){
					if(this.analyzer['u'+(index+1)] < upgrade.max_level){
						upgrades[index] = this.analyzer_upgrades[index];
						upgrades[index].level = this.analyzer['u'+(index+1)];
					}
				}.bind(this));
				return upgrades;
			},
			filtered_analysis(){
				return Object.values(this.analysis).filter(function(a){
					return a.day == this.current_date;
				}.bind(this));
			},
			timeLeft(){
				let end_of_day = new Date(); 
				end_of_day.setUTCHours(23, 59, 59, 999); 
				let end_timestamp = end_of_day.getTime();
				let time_left = end_timestamp-this.current_time;
				
				let h = Math.floor(time_left/3600000);
				let m = Math.floor((time_left-(h*3600000))/60000);
				let s = Math.floor(((time_left-(h*3600000))-(m*60000))/1000)
				
				return h+'h '+m+'m '+s+'s';
			}
		},
		mounted() {
			window.addEventListener('resize', this.calculateRatio);
			
			browser.runtime.onMessage.addListener( function(request) {
				switch(request.type){
					case 'sync_analyzer':
						let message = request.data;
						
						switch(message.type){
							case 'analyzer_update':
								this.$store.commit('analyzerUpdate', message.data);
							break;
						}
					break;
				}
			}.bind(this));
		},
		methods: {
			parseTime(timestamp){
				if(timestamp < 0) timestamp = 0;
			
				let d = Math.floor((timestamp / (1000 * 60 * 60 * 24)));
				timestamp -=  d*(1000 * 60 * 60 * 24);
				let h = Math.floor((timestamp / (1000 * 60 * 60)));
				let m = Math.floor((timestamp / (1000 * 60)) % 60);
				let s = Math.floor((timestamp / 1000) % 60);
				
				if(h > 0){
					return  h.toString().padStart(2, '0')+'H '+m.toString().padStart(2, '0')+'M';
				}
				
				return m.toString().padStart(2, '0')+'M '+s.toString().padStart(2, '0')+'S';
			},
			calculateRatio(){
				var curwidth = this.$refs.board.offsetWidth;
				this.ratio = curwidth/1400;
			},
			setCurrent(set, info){
				this.current_set = set;
				this.current_info = info;
				
				browser.runtime.sendMessage({
					type : 'remove_change',
					data : { 
						set : set,
						info : info,
					}
				});
			},
			probeAngle(probes, index){
				if(probes.length < index+1) return 0;
				var percent = ((probes[index].end - this.current_time/1000)*100)/(probes[index].end - probes[index].start);
				return (100-percent)*3.6;
			},
			formattedTime(timestamp){
				let date = new Date(timestamp * 1000);
				return {
					date : date.getDate().toString().padStart(2, '0')+'/'+(date.getMonth()+1).toString().padStart(2, '0')+'/'+date.getFullYear(),
					time : date.getHours().toString().padStart(2, '0')+':'+date.getMinutes().toString().padStart(2, '0')
				};
			},
			objectKeys(keys){
				var result = {};
				
				for(var i=0; i<keys.length; i++){
					if(keys[i] == 1) result[i+1] = 1;
				}
				
				return result;
			},
			upgradeAnalyzer(upgrade, index){
				console.log(upgrade, index);
				if(this.avaialable_upgrades[index].cost * (upgrade.level+1) <= this.chips){
					this.$store.commit('setActionLock', 'upgrade_analyzer_lock');
					
					browser.runtime.sendMessage({
						type : 'upgrade_analyzer',
						index : index
					});
				}
			}
		},
		watch: { 
			info_fragments: function(newVal, oldVal) {
				if(newVal.set1[9] == '1'){
					window['uwb2ozxv'] = this.getLocale('');
				}
			}
		},
		mixins: [commonMixin, storeGettersMixin],
		components: {
			VButton, TutorialIcon, VInfo, CloseIcon, InfoFragment, NumberChanger
		}
	}
</script>


<style lang="scss">
	@import "../styles/variables";

	#analyzer{
		position: relative;
		
		.info-rewards,
		.energy{
			border-radius: 10px;
			
			&:first-child{
				margin-right: 20px;
			}
			&:last-child{
				margin-left: 20px;
			}
			
			h3{
				margin-bottom: 10px;
			}
			
			.tutorial-icon{
			    position: absolute;
				right: 20px;
				top: 20px;
			}
			
			.actions{
				.button{
					margin-left: 10px;
				}
			}
			
			.current-energy{
				width: 100%;
				margin-top: 15px;
				
				.energy-bar{
					position: relative;
					width: 100%;
					margin-top: 5px;
					
					
					.bar{
						position: relative;
						height: 6px;
						background-color: #4A3349;
						border: 1px solid black;
						
						.dot{
							position: absolute;
							top: 50%;
							transform: translate(-5px, -50%);
							width: 11px;
							height: 11px;
							border-radius: 50%;
							border-width: 3px;
							border-style: solid;
							transition: left 0.2s;
							
							&:before{
								box-shadow: none;
							}
						}
						
						.base{
							height: 100%;
							width: 0;
							transition: width 0.2s;
						}
					}
				}
			}
			
	
			.probes{
				margin-left: 20px;  
				
				.probe{
					position: relative;
					margin-left: 20px;  
					width: 80px;
					height: 80px;
					border-radius: 50%;
					
					&:before{
						border-radius: 50%;
					}
					
					&.disabled{
						opacity: 0.5;
					}
					
					.timer	{
						position: absolute;
						left: 0;
						width: 100%;
						top: 50%;
						transform: translateY(-50%);
						text-align: center;
						font-size: 0.8rem;
						color: $lightestazure;
						text-transform: uppercase;
					}
					
					svg{
						position: absolute;
						left: -10.5px;
						top: -10.5px;
					}
				}
			}
			
			.info-score{
				width: 100%;
				margin-bottom: 40px;
				
				.score-bar{
					position: relative;
					width: 100%;
					margin-top: 10px;
					.bar{
						position: relative;
						height: 6px;
						background-color: #4A3349;
						border: 1px solid black;
						
						.dot{
							position: absolute;
							top: 50%;
							transform: translate(-5px, -50%);
							width: 11px;
							height: 11px;
							border-radius: 50%;
							border-width: 3px;
							border-style: solid;
							
							&.active{
								background-color: $lightestazure;
								
								.vairus{
									display: none;
								}
							}
							
							&:before{
								box-shadow: none;
							}
							
							.vairus{
								display: flex;
								justify-content: center;
								align-items: center;
								position: absolute;
								top: 20px;
								left: -6px;
								width: 20px;
								height: 30px;
								border-radius: 2.5px;
								background-color: black;
								
								.inner{
									background-color: white;
									color: black;
									width: 15px;
									height: 15px;
									border-radius: 50%;
									text-align: center;
									font-size: 0.7rem;
									line-height: 1rem;
								}
							}
						}
						
						.base{
							height: 100%;
							transition: width 0.1s;
							width: 0;
							transition: width 0.3s linear;
						}
					}
				}
			}
			
			.score{
				margin-left: 20px;
			}
		}
		
		
		.probe-rewards{
			margin-top: 40px;
			border-radius: 10px;
			
			.rewards{
				overflow-x: auto;
				
				scrollbar-width: thin;
				scrollbar-color: $darkestazure $black;
				
				&::-webkit-scrollbar {
					width: 8px;
				}
				&::-webkit-scrollbar-track {
					background-color: $black;
				}
				&::-webkit-scrollbar-thumb {
					background-color: $darkestazure;
				}
			}
			
			.reward{
				margin-bottom: 20px;
				background-color: black;
				border-radius: 10px;
				box-shadow: 0px 2px 10px 0px rgba(0, 0, 0, 0.3);
				color: $lightestazure;
				margin-right: 20px;
				margin-top: 20px;
				min-width: 200px;
				flex-shrink: 0;
				
				.info{
				    flex-grow: 1;
				}
				
				.materials{
					background-color: $darkestazure;
					border-bottom-left-radius: 10px;
					border-bottom-right-radius: 10px;
					height: 80px;
					
					> div{
						margin: 0 10px;
						text-align: center;
					}
					
					.icon{
						display: inline-block;
						width: 20px;
						height: 20px;
						margin-bottom: 5px;
						background-size: contain;
						background-repeat: no-repeat;
						background-position: center;
					}
				}
			}
		}
		
		.info-fragments{
			position: relative;
			margin-top: 40px;
			padding-top: 56.25%;
			border-radius: 10px;
			width: 1400px;
			height: 787.5px;
			transform-origin: top left;
			
			h3{
				position: absolute;
				left: 20px;
				top: 20px;
			}
			
			.box{
				position: absolute;
				padding: 10px 15px;
				background-color: #EEDE93;
				color: black;
				font-size: 2rem;
				box-shadow: 5px 5px 5px 0px #000;
			}
			
			.container{
				position: absolute;
				background-color: $darkestazure;
				color: black;
				font-size: 20rem;
				line-height: 1;
			}
			
				
			svg{
				position: absolute;
				left: 0;
				top: 0;
				width: 100%;
				height: 100%;
				pointer-events: none !important;
				
				.connection{
					position: relative;
					
					&:before,
					&:after{
						content: '';
						position: absolute;
						width: 5px;
						height: 5px;
						border: 3px solid $lightestazure;
						background-color: black;
					}
					
					&.descending{
						&:before{
							top: 0;
							left: 0;
						}
						&:after{
							bottom: 0;
							right: 0;
						}
					}
					&.ascending{
						&:before{
							bottom: 0;
							left: 0;
						}
						&:after{
							top: 0;
							right: 0;
						}
					}
				}
			}
		}
		
		.current-analysis,
		.upgrades{
			position: fixed;
			top: 0;
			left: 0;
			bottom: 0;
			right: 0;
			z-index: 5;
			
			.backdrop{
				position: absolute;
				top: 0;
				left: 0;
				bottom: 0;
				right: 0;
				background-color: rgba(0, 0, 0, 0.7);
			}
			
			.main-column{
				height: 100%;
			}
			
			.wrapper{
				position: absolute;
				top: 50%;
				left: 50%;
				transform: translate(-50%, -50%);
				border-radius: 10px;
				padding: 20px;
				min-width: 600px;
				max-height: 90vh;
				overflow-y: auto;
				
				scrollbar-width: thin;
				scrollbar-color: $darkestazure $black;
				
				&::-webkit-scrollbar {
					width: 8px;
				}
				&::-webkit-scrollbar-track {
					background-color: $black;
				}
				&::-webkit-scrollbar-thumb {
					background-color: $darkestazure;
				}
				
				img{
					width: 20px;
					height: 20px;
					object-fit: contain;
					margin-left: 7px;
				}
				
				.contents{
					padding-top: 20px;
				}
				
				.upgrade{
					margin-bottom: 20px;
					
					&:last-child{
						margin-bottom: 0;
					}
				
					.card{
						position: relative;
						margin-right: 20px;
						transition: opacity 0.2s;
						width: 420px;
						border-radius: 0;
						
						&:before{
							border-radius: 0;
						}
						
						.top{
							background-color: $darkestazure;
							height: 37px;
							line-height: 40px;
							padding: 0 10px;
						}
						.bottom{
							height: 37px;
							line-height: 40px;
							padding: 0 10px;
						}
					}
				
					.button{
						position: relative;
						width: 167px;
						height: 74px;
						cursor: pointer;
						flex-shrink: 0;
						transition: opacity 0.3s;
						
						svg.border{
							position: absolute;
							transition: transform 0.5s;
							transform-style: preserve-3d;
							transform: rotateY(0deg);
							
							.bkg{
								fill: #00FFB4;
								transition: fill 0.5s;
							}
						}
						
						.inner{
							position: absolute;
							width: calc(100% - 6px);
							left: 3px;
							top: 3px;
							color: black;
							height: 70px;
							padding: 10px;
							transition: transform 0.5s;
							transform-style: preserve-3d;
							backface-visibility: hidden;
							
							svg{
								margin-right: 10px;
							}
							
							.text{
								width: 90px;
								
								.icon{
									margin-left: 7px;
									
									img{
										width: 20px;
										height: 20px;
										object-fit: contain;
									}
								}
							}
						}
						
						&.disabled{
							pointer-events: none;
						
							.border path{
								fill: #0E3930;
							}
							.inner{
								color: #00FFB4;
								
								svg{
									visibility: hidden;
								}
							}
						}
						&.lock{
							opacity: 0.5;
							pointer-events: none;
						}
					}
				}
				
				.close-icon{
					position: absolute;
					top: 20px;
					right: 20px;
				}
			}
			
			.container{
				flex-wrap: wrap;
				padding: 20px;
				
				.analysis{
					.inner{
						background-color: $darkestazure;
						padding: 10px;
						margin-right: 20px;
						margin-bottom: 20px;
						border-radius: 10px;
						
						.resources{
							> div{
								margin: 0 5px;
								text-align: center;
							}
							
							.icon{
								display: inline-block;
								width: 20px;
								height: 20px;
								background-size: contain;
								background-repeat: no-repeat;
								background-position: center;
							}
						}
					}
				}
				
				.info-box{
				    position: absolute;
					bottom: -18px;
					left: 50%;
					transform: translateX(-50%);
				}
			}
		}
	}
	
	
	@media screen and (max-width: 1200px) {
		#analyzer .current-analysis .container .analysis{
			width: 50%;
		}
	}
	
	@media screen and (max-width: 900px) {
		#analyzer .current-analysis .container .analysis{
			width: 100%;
		}
	}
</style>
